package com.ruoyi.gysl.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.gysl.entity.BuildingInformation;
import com.ruoyi.gysl.entity.Xmpjqd;
import com.ruoyi.gysl.entity.request.XmpjqdPageReq;
import com.ruoyi.gysl.entity.response.XmhxDetail.XmhxDetail;
import com.ruoyi.gysl.entity.response.XmpjqdOneResponse;
import org.apache.ibatis.annotations.Param;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.List;

/**
 * 项目评价清单(Xmpjqd)表数据库访问层
 *
 * @author makejava
 * @since 2025-03-22 09:22:33
 */
public interface XmpjqdMapper extends BaseMapper<Xmpjqd> {

    /**
     * 分页查询所有目录
     *
     * @param page 分页对象
     * @return 所有数据
     */
    Page<Xmpjqd> page(Page<Xmpjqd> page, @Param("req") XmpjqdPageReq req);

    /**
     * 通过主键查询项目的总投资额排名
     *
     * @param id 主键
     * @return 单条数据
     */
    List<XmpjqdOneResponse> selectOnePj(@Param("id") Long id);

    /**
     * 查询所有的建筑信息,只保留是重要楼栋的第一条
     */
    List<BuildingInformation> getImportantBuildings();


    /**
     * 通过主键查询单条项目画像
     *
     * @param id 主键
     * @return 单条数据
     */
    List<XmhxDetail> oneXmhx(@Param("id") Serializable id);

    /**
     * 总投资额中位数
     */
    List<BigDecimal> zwsXmhx();


    /**
     * 最大值
     */
    List<XmhxDetail> maxXmhx();

}

